When submitting a solution in C++, please select either C++14 (GCC 6-32) or C++17 (GCC 7-32) as your compiler. ×

awoo's blog

By awoo, history, 5 years ago, translation, In English

1155A - Reverse a Substring

Tutorial
Solution (Vovuh)

1155B - Game with Telephone Numbers

Tutorial
Solution (Roms)

1155C - Alarm Clocks Everywhere

Tutorial
Solution (Vovuh)

1155D - Beautiful Array

Tutorial
Solution (PikMike)

1155E - Guess the Root

Tutorial
Solution (adedalic)

1155F - Delivery Oligopoly

Tutorial
Solution (BledDest)
  • Vote: I like it
  • +78
  • Vote: I do not like it

| Write comment?
»
5 years ago, # |
  Vote: I like it +105 Vote: I do not like it

My approach for problem D is quite different. I hope it would be easy to understand.

At first, I build 2 arrays Left(i) and Right(j) that return the maximum sum of a subarray ending at i with Left(i) and starting at j with Right(j). I also have array Sum(i) is sum of all elements from 1 to i.

When we multiply the subarray (l..r), the result in current case is

Left(l-1) + x * (Sum(r) - Sum(l-1)) + Right(r+1).

We can rewrite it by

(Right(r+1) + x * Sum(r)) + (Left(l-1) - x * Sum(l-1)).

With this formula, my solution is a loop for i from 1 to n, take i as the right most of the multiply subarray, get the best value of the left most to update the answer.

See my submission for more details: 53150702

  • »
    »
    5 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    i prefer your solution to this editorial's solution. Your solution is more interesting and easier for me to understand. Love it

  • »
    »
    5 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Can u please explain the formula part in detail I am not able to understand it?

    • »
      »
      »
      5 years ago, # ^ |
      Rev. 2   Vote: I like it +1 Vote: I do not like it

      Let 's take subarray (l..r) to multiply.

      The sum of this segment is Sum(r) — Sum(l-1) and after multiply is x * (Sum(r) — Sum(l-1)).

      But we don't stop at this with x is negative number. You can see the first test case, we would try to increase the answer by openning its border.

      What is best way to do that? My solution is using arrays Left and Right.

  • »
    »
    5 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Loved your approach

  • »
    »
    5 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    What a great solution!!

  • »
    »
    5 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    So good

  • »
    »
    5 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Admire !

  • »
    »
    5 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    I am unable to understand why did you do this res = max (res, Left[i]); when you had to maximize just these two terms in the last loop Right(r+1) + x * Sum(r)) + (Left(l-1) — x * Sum(l-1))

    • »
      »
      »
      5 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      We can choose " at most one consecutive subarray of a " but my math expression is just correct when I choose a non-empty subarray from l to r.

  • »
    »
    5 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    thank you , your solution is more easier than tutorial

  • »
    »
    4 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Beautiful Solution!!!

  • »
    »
    4 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    This approach really helped a lot man ..thanx :)

  • »
    »
    3 years ago, # ^ |
    Rev. 3   Vote: I like it 0 Vote: I do not like it

    [user:l0s3r]Can you explain why you did res = max (res, Left[i]); in your code?

  • »
    »
    3 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Brilliant way of rearranging and solving complex things in easy way kudos to you!

»
5 years ago, # |
  Vote: I like it -65 Vote: I do not like it

why is E so easy

»
5 years ago, # |
  Vote: I like it +7 Vote: I do not like it

I can't get my head around as to why greedy won't work for D. If x is non positive, why can't we just find the maximum negative sum and multiply it by x? My code doesn't pass, so it is definitely wrong, but I don't know why.

  • »
    »
    5 years ago, # ^ |
    Rev. 2   Vote: I like it +9 Vote: I do not like it

    Edit: my bad, I gave a wrong example. See the responses.

    • »
      »
      »
      5 years ago, # ^ |
      Rev. 2   Vote: I like it +5 Vote: I do not like it

      I think your example is wrong cause multiplying x with -2 also gives 2+10-1+10 = 21.

      One example can be :

      7 -1

      -20 21 -15 10 -10 20 10.

      Here -20 is the largest non-positive segment but it gives 20+21-15+10-10+20+10 = 56.

      But multiplying -15 by -1 gives 21+15+10-10+20+10 = 66

    • »
      »
      »
      5 years ago, # ^ |
        Vote: I like it +5 Vote: I do not like it

      In your example, you'd get 21 in either case. What you wanted to say was:

      4 -1
      -5 10 -3 10
      
»
5 years ago, # |
  Vote: I like it +5 Vote: I do not like it

Is there another way to get the polynomial on problem E? ( Not using Gaussian elimination )

  • »
    »
    5 years ago, # ^ |
      Vote: I like it +21 Vote: I do not like it

    You can use lagrange interpolation

»
5 years ago, # |
  Vote: I like it +14 Vote: I do not like it

I have an approach for D that is more in the 'style' of Kadane's algorithm. The beautiful part of the array consists of 3 "segments", the 1 part, the X part, and the 1 part again.

Like Kadane's, we loop through each x in the array, maintaining bestK = the largest value of K segments ending in the current x value.

def solve(N, X, A):
    ans = best1 = best2 = best3 = 0
    for a in A:
        best3 = max(0, a, best1 + a, best2 + a, best3 + a)
        best2 = max(0, X*a, best1 + X*a, best2 + X*a)
        best1 = max(0, a, best1 + a)
        ans = max(ans, best1, best2, best3)
    return ans
  • »
    »
    5 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Can you explicate the best3?

    • »
      »
      »
      5 years ago, # ^ |
      Rev. 8   Vote: I like it 0 Vote: I do not like it

      Let A[i:j] denote the sum A[i] + ... + A[j] For a given j,

      best1 = largest possible A[i:j]
      best2 = largest possible A[h:i-1] + A[i:j] * X
      best3 = largest possible A[g:h-1] + A[h:i-1] * X + A[i:j] 
      
      • »
        »
        »
        »
        4 years ago, # ^ |
          Vote: I like it 0 Vote: I do not like it

        Wow I learned the essence of kadanes algorithm from your solution

  • »
    »
    5 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Thank You!

»
5 years ago, # |
  Vote: I like it +10 Vote: I do not like it

For problem B, wasn't it enough to simply ignore the last 10 characters of the string and check whether more than half of the remaining characters are equal to '8'?

  • »
    »
    5 years ago, # ^ |
    Rev. 3   Vote: I like it +5 Vote: I do not like it

    Yes. If the number of 8's is at most (n - 11) / 2 or the number of moves each person gets, Petya can remove all the 8's. The number of digits that are not 8's is n - 10 - numberOf8s, therefore if the number of 8's is greater than (n - 11) / 2 the number of digits that are not 8 will be less than n - 10 - (n - 11) / 2 = (n - 9) / 2, which is at most (n - 11) / 2. So Vasya would be able to remove all the non-8's.

»
5 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Can anyone explain editorial's tutorial for problem D in simple and easy way.

»
5 years ago, # |
  Vote: I like it 0 Vote: I do not like it

I honestly don't get why my solution isn't working. I get WA on the 11th test case, but the output seems fine to me. Am I missing something?

https://codeforces.com/contest/1155/submission/53204105

  • »
    »
    5 years ago, # ^ |
      Vote: I like it +24 Vote: I do not like it
    for ( int i = 1; i < n-1; ++i ) {
        gcd = __gcd(dif[i], dif[i+1]);
    }
    

    Try to find here.

»
5 years ago, # |
  Vote: I like it +6 Vote: I do not like it

In problem E, how can we be sure that the value of f(xi) that we use to interpolate the polynomial is actually the value of the polynomial or less than the actual value because of MOD 1e6 + 3

For example, if the polynomial is 1 + (1e6+1)x + x^2, f(0) = 1, f1(1) = 1e6+2, f(2) = 2e6 + 7 MOD 1e6 + 3 = 1. Now the polynomial we interpret will be wrong.

  • »
    »
    5 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Isn't f(1) = 1e6+3 = 0?

    • »
      »
      »
      5 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      my bad. But the point stands? The function could be changed.

      • »
        »
        »
        »
        5 years ago, # ^ |
          Vote: I like it 0 Vote: I do not like it

        If you do the interpolation with the correct values you'll end up with the correct polynomial and I believe that it will always be correct because of the way modular arithmetic works.

        • »
          »
          »
          »
          »
          5 years ago, # ^ |
            Vote: I like it 0 Vote: I do not like it

          So assume that the question said instead of 11 degrees the polynomial is 2 degrees only. Then the polynomial interpolated from above info is 1 — 2x + x^2, again obviously wrong. Maybe, it will give the correct value of zero when taken MOD 1e6+3 but I don't find in intuitively clear.

          • »
            »
            »
            »
            »
            »
            5 years ago, # ^ |
              Vote: I like it +3 Vote: I do not like it

            -2 is congruent to 1e6 + 1 mod 1e6 + 3, so 1 — 2x + x^2 is congruent to 1 + (1e6 + 1)x + x^2 mod 1e6 + 3 and the interpolated polynomial is correct.

»
5 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Another approach for problem D

We find the Best subarray ending at ith index and at every index maintain three possible sums 1) x has not yet been used previously nor being used by this element 2) x is being used by this element 3) x was used by some prev segment and hence this element cannot use x

Transitions for calculating ith index results

1) is simple to extend using prev index's result

2) either extend prev index result 1) or 2) should multiply a[i] by x

3) can extend 2) or 3) but should not multiply a[i] by x

https://codeforces.com/contest/1155/submission/53223589

»
5 years ago, # |
  Vote: I like it +5 Vote: I do not like it

My "solution" for F: first use dp to calculate for each subset of vertices and each pair of vertices if there is a path between those vertices passing through exactly gives subset of vertices, exactly once. From this we can get for each subset if there is a cycle passing through each of them exactly once. Iterate over all subsets and identify those, which have a Hamiltonian cycle, but none of their proper supersets does. Now while we have time left pick a random of those subsets, put all edges from the cycle to the graph, random_shuffle all other edges, add them in order and if this edge is not redundant (i.e their endpoints aren't already in the same biconnected componend) add it. After each iteration check if current solution is better, than best found so far. If it is store it. I saw some other people getting accepted with similar approach. Any idea how to defeat it? 53200092

»
5 years ago, # |
Rev. 3   Vote: I like it +15 Vote: I do not like it

I've solved problem F with a random way. We can delete some edges in E, and then run Tarjan algorithm to find all strongly connected components. If the graph is bi-connected, the all nodes are supposed to form a single strongly connected component. The number of deletion strategy is 2^|E|, it's too large to try all possible strategies. But we can turn to a greedy way, iterate over each edge, if it's redundant, just delete it. You need run the process several times to get a satisfying result, before each process, shuffle the E at first.

  • »
    »
    5 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    That's quite unfortunate.

    I think if the edges were weighted the model solution would look the same, but any randomized shit would be in trouble because e.g. for random weights it's very likely that optimal solution is unique, or the assertion I used that if for some set of vertices with Hamiltonian cycle there is its superset which also has a Hamiltonian cycle is no longer true.

  • »
    »
    5 years ago, # ^ |
    Rev. 2   Vote: I like it 0 Vote: I do not like it

    Can you share your submission?...@dalt

»
5 years ago, # |
Rev. 2   Vote: I like it 0 Vote: I do not like it

I find a way using greedy and segment tree to solve D You can see my submission 53466247.awoo

  • »
    »
    5 years ago, # ^ |
      Vote: I like it +2 Vote: I do not like it

    Can you explain your solution?

    • »
      »
      »
      5 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      Let we make l the start of the range we multiple x.And then we need to find best r to be the end of the range we multiple x.The answer of [l,r] to multiple x is left[l]+sum(l,r)*x+right[r].Because the left[l] is fixed, we only need to consider sum(l,r)*x+right[r].Then we can use a segment tree to find the best r quickly.

»
5 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Problem E: What would be the problem if the limit was not a prime?? Can anyone explain??

  • »
    »
    5 years ago, # ^ |
      Vote: I like it +1 Vote: I do not like it

    In this problem, we use Gaussian Elimination to solve a modular SLAE (System of Linear Algebraic Equations). In Gaussian Elimination, some steps involve division operations. So, the division steps, in this case, involve finding out the multiplicative inverse of the denominator and multiplying the numerator by that. The multiplicative inverses may not exist if the module is not prime and in that case, we will not be able to use Gaussian Elimination to solve the problem.

»
5 years ago, # |
  Vote: I like it +3 Vote: I do not like it

Where can I read about Gaussian elimination method?

  • »
    »
    4 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    change ur profile pic i thought there is something on my screen so tried to rub it off

»
5 years ago, # |
  Vote: I like it 0 Vote: I do not like it

For problem D can someone explain me what ecnerwala did to solve it. His code looks quite simple but I am unable to understand it :( . Here's the link to his solution 53141642

  • »
    »
    4 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Okay, so this is what I understood:

    A number can be in these 5 states:

    1. Not included in the range, and is to the left of the included range
    2. Included in the range, but not multiplied by x, before the range that is multiplied by x
    3. Included in the range, and multiplied by x
    4. Included in the range, but not multiplied by x, after the range that is multiplied by x
    5. Not included in the range, and is to the right of the included range.

    This gives you good information about the first loop.

    The second loop is about saying "the maximum sum, doing whatever, before the current element".

    So for (int z = 0; z+1 < 5; z++) dp[z+1] = max(dp[z+1], dp[z]); makes dp useful for the next for (int z = 0; z < 5; z++) dp[z] += weights[z] * v; Where, we calculate: dp[i] = dp[i](The max until i, by including, not including, multiplying etc) + weights[i]*v(the weight according to state) ;

  • »
    »
    4 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    that is damn cool

»
5 years ago, # |
Rev. 2   Vote: I like it 0 Vote: I do not like it

what is wrong in this code 1155D

include<bits/stdc++.h>

using namespace std;

define ll long long

define mod 1000000007

define pii pair<ll,ll>

define mp make_pair

define se second

define fi first

define pb push_back

ll max(ll a,ll b) { if(a>b) return a; return b;

}

int main() { ll n,x; cin>>n>>x; ll a[10000007]={0}; for(ll i=0;i<n;i++) { cin>>a[i];

}
ll dp[100005][3];
dp[0][0]=max(a[0],0);
dp[0][1]=max(a[0]*x,0);
dp[0][2]=max(a[0],0);
for(ll i=1;i<n;i++)
{
    dp[i][0]=max(0,dp[i-1][0]+a[i]);
    dp[i][0]=max(dp[i][0],dp[i][2]+a[i]);
    dp[i][2]=max(dp[i-1][1]+a[i],dp[i][0]);
    dp[i][2]=max(dp[i-1][2]+a[i],dp[i][2]);
    dp[i][2]=max(0,dp[i][2]);

    dp[i][1]=max(dp[i-1][0]+a[i]*x,dp[i-1][1]+a[i]*x);
    dp[i][1]=max(0,dp[i][1]);
}
ll maxi=0;
for(ll i=0;i<n;i++)
{
    for(ll j=0;j<3;j++)
    {
    // cout<<dp[i][j]<<" ";
    if(maxi<dp[i][j])
    maxi=dp[i][j];
    }
//  cout<<endl;
}

cout<<maxi;

}

»
5 years ago, # |
Rev. 2   Vote: I like it +3 Vote: I do not like it

1155D - Beautiful Array — My solution is similar to alexwice and arajatchauhan813, you just have a dp table of n * 3 in which you have:

dp[i][1]:the maximum sum without multiplying until i

dp[i][2]:the maximum sum up to i having already multiplied and without multiplying from i

dp[i][3]:the maximum sum up i multiplying a piece that ends in i

Then :

    for(int i=0;i<n;i++){

        dp[i][1]=max(0ll,arr[i]);

        dp[i][2]=max(0ll,arr[i]);

        dp[i][3]=max(0ll,arr[i]*x);

        if(i==0)continue;

        dp[i][1]=max({ dp[i][1] , arr[i]+dp[i-1][1] });

        dp[i][2]=max({ dp[i][2] , arr[i]+dp[i-1][2] , arr[i]+dp[i-1][3]});

        dp[i][3]=max({ dp[i][3] , dp[i-1][3]+(arr[i]*x) , dp[i-1][1]+(arr[i]*x)});

    }

So you only need visit the table and find the greatest solution

There is my solution 55211386